package com.albertoventurini.parsley.examples.markdown;

import com.albertoventurini.parsley.grammar.Grammar;
import com.albertoventurini.parsley.grammar.rules.Rule;

import static com.albertoventurini.parsley.grammar.rules.Rules.*;

public class MarkdownGrammar extends Grammar {

    private final Rule h1 = sequence(
            character('#'),
            takeWhile(c -> c != '\n')
    );

    private final Rule paragraph = sequence(
            character('\n'),
            takeWhile(c -> c != '\n')
    );

    private final Rule element = oneOf(h1, paragraph);

    private final Rule elements = sequence(element);

    private final Rule document = zeroOrMore(elements);

    @Override
    public Rule startRule() {
        return document;
    }

    @Override
    protected Rule commentRule() {
        return null;
    }
}
