package com.albertoventurini.parsley.grammar;

import com.albertoventurini.parsley.grammar.rules.Rule;

import java.util.Optional;

public abstract class Grammar {

    protected abstract Rule startRule();

    protected abstract Rule commentRule();

    public Optional<ParseTree> parse(final String text) {
        final var ctx = new GrammarContext(text, commentRule());
        return startRule().apply(ctx);
    }

}
