package com.albertoventurini.parsley.grammar.rules;

import java.util.function.Predicate;

public class Rules {

    public static MatchCharacter character(final char c) {
        return new MatchCharacter(c);
    }

    public static AnyCharacter anyChar() {
        return new AnyCharacter();
    }

    public static MatchString string(final String s) {
        return new MatchString(s);
    }

    public static TakeWhileCharacter token() {
        return new TakeWhileCharacter();
    }

    public static TakeWhileCharacter takeWhile(final Predicate<Character> characterPredicate) {
        return new TakeWhileCharacter(characterPredicate);
    }

    public static UntilString until(final String s) {
        return new UntilString(s);
    }

    public static Sequence sequence(final Rule... rules) {
        return new Sequence(rules);
    }

    public static OneOf oneOf(final Rule... rules) {
        return new OneOf(rules);
    }

    public static ZeroOrMore zeroOrMore(final Rule childRule) {
        return new ZeroOrMore(childRule);
    }

    public static ZeroOrOne zeroOrOne(final Rule childRule) {
        return new ZeroOrOne(childRule);
    }

    public static OneOrMore oneOrMore(final Rule childRule) {
        return new OneOrMore(childRule);
    }

    public static Wrapper wrapper() {
        return new Wrapper();
    }
}
